import { createRouter, createWebHistory } from 'vue-router'
import Dataset from '@/views/Dataset.vue'
import DatasetDetail from '@/views/DatasetDetail.vue'
import ProjectDetail from '@/views/ProjectDetail.vue'
import Project from '@/views/Project.vue'
import SignIn from '@/views/SignIn.vue'
import SignUp from '@/views/SignUp.vue'
import { useAuthStore } from '@/stores/mytoken'
import TrainDetail from '@/views/TrainDetail.vue'



const router = createRouter({
  history: createWebHistory(),
  routes: [
    {
      path: '/',
      component: Project,
      meta: { requiresAuth: true}
    },
    {
      path: '/sign-in',
      name: "sign-in",
      component: SignIn
    },
    {
      path: '/sign-up',
      name: "sign-up",
      component: SignUp
    },
    {
      path: '/project',
      component: Project,
      meta: { requiresAuth: true}
    },
    {
      path: '/dataset',
      component: Dataset,
      meta: { requiresAuth: true}
    },
    {
      path:'/project-detail',
      component: ProjectDetail,
      meta: { requiresAuth: true}
    },
    {
      path:'/dateset-detail',
      component: DatasetDetail,
      meta: { requiresAuth: true}
    },
    {
      path:'/train-detail',
      component: TrainDetail,
      meta: { requiresAuth: true}
    }
  ]
})

router.beforeEach((to, from, next)=>{
  if (to.matched.some(r=>r.meta.requiresAuth)){
    const store = useAuthStore()
    if (!store.accessToken) {
      next({name: 'sign-in'})
    }
  }

  next()
})

export default router
